<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE></TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 1.1.5  (Linux)">
	<META NAME="CREATED" CONTENT="20070626;14051800">
	<META NAME="CHANGED" CONTENT="20070710;12270500">
</HEAD>
<BODY LANG="en-US" DIR="LTR">
<P STYLE="margin-bottom: 0in"><FONT SIZE=6><B>Build LL(1) Parse Table</B></FONT></P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in">Contents</H2>
<P STYLE="margin-bottom: 0in"><A HREF="#definition"><U>Definition</U></A></P>
<P STYLE="margin-bottom: 0in"><A HREF="#How to Build LL(1) Parse Table|outline">How
to Build LL(1) Parse Table</A></P>
<UL>
	<LI><P STYLE="margin-bottom: 0in"><A HREF="#Enter FIRST Sets|outline">Enter
	FIRST Sets</A></P>
	<LI><P STYLE="margin-bottom: 0in"><A HREF="#Enter FOLLOW Sets|outline">Enter
	FOLLOW Sets</A></P>
	<LI><P STYLE="margin-bottom: 0in"><A HREF="#Enter LL(1) Parse Table|outline">Enter
	LL(1) Parse Table</A></P>
</UL>
<P STYLE="margin-bottom: 0in"><A HREF="#LL(1) Parsing|outline"><U>LL(1)
Parsing</U></A></P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="definition"></A>
Definition</H2>
<P STYLE="margin-bottom: 0in">The type of LL parsing in JFLAP is
LL(1) Parsing. 
</P>
<P STYLE="margin-bottom: 0in">The first L means the input string is
processed from left to right.<BR>The second L means the derivation
will be a leftmost derivation (the leftmost variable is replaced at
each step). <BR>1 means that one symbol in the input string is used
to help guide the parse.</P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<H2 STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="how to"></A><A NAME="How to Build LL(1) Parse Table|outline"></A>
How to Build LL(1) Parse Table</H2>
<P><A NAME="language1"></A>We will begin by loading the grammar. You
can either enter the grammar (shown below) or load the file
<A HREF="grammarToLL.jff">grammarToLL.jff</A>. 
</P>
<P ALIGN=CENTER><A NAME="editor"></A><IMG SRC="images/grammarwindow.png" NAME="Graphic1" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P STYLE="margin-bottom: 0in">Now click on <B>Input </B>and then
<B>Build LL(1) Parse Table</B>. Your window should look like this
after entering LL(1) Parse Table mode. 
</P>
<P STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/llparsetable.png" NAME="Graphic2" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<H2 ALIGN=LEFT STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="Enter FIRST Sets|outline"></A>
Enter FIRST Sets</H2>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now, the first step is to
enter in <B>FIRST</B> sets. A <B>FIRST</B> set of a string of
variables and terminals is the set of terminals that can first appear
in the derived string. For instance, variable “A” can derive
either lambda or some string that starts with “a”. Thus, we
should put “a” and lambda in the <B>FIRST</B> set for variable
“A”. You can enter lambda by writing “!”. We can fill in the
<B>FIRST</B> set of start variable “S” by putting terminal “a”
in the set, since the “S” production begins with terminal “a”.
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in; font-weight: medium">*<B>NOTE</B>
: When you want to enter two terminals into a set, just write them
without any spaces. For example in order to put lambda and terminal
“a” into the <B>FIRST</B> set of “A”, you would simply type
“!a” in the appropriate column.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">After entering <B>FIRST</B>
sets for variables “S” and “A”, your <B>LL(1) Parse</B>
window should look like this : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_1.png" NAME="Graphic3" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now we have to enter the
<B>FIRST</B> set for variable “B”. Suppose we enter “d” as
the <B>FIRST</B> set of variable “B”. Clearly, the variable “B”
does not produce any string that would begin with “d”. JFLAP
detects this error when you press <B>NEXT</B> button.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in; font-weight: medium">You
would receive an error message like this one : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_2.png" NAME="Graphic6" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">After correcting the error
by entering “b” and “c” as the <B>FIRST </B>set of variable
“B”, we can click <B>Next</B>. If our <B>FIRST </B>sets are all
correct then a message tells us to define <B>FOLLOW</B> sets. 
</P>
<H2 ALIGN=LEFT STYLE="margin-top: 0in; margin-bottom: 0in"><BR>
</H2>
<H2 ALIGN=LEFT STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="Enter FOLLOW Sets|outline"></A>
Enter FOLLOW Sets</H2>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now, we need to enter the
proper <B>FOLLOW</B> sets for each variable as we did for the <B>FIRST
</B>sets. The <B>FOLLOW</B> set of variable “X” is a set of
terminals that can immediately follow “X” in some derivation. 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in; font-weight: medium">The
<B>FOLLOW</B> set for variable “A” contains terminal “c” and
“b”. It is quite obvious to notice that terminal “c” follows
variable “A” in production “A-&gt;aAc”. However, it is not
quite obvious to see where the terminal “b” follows variable “A”.
In the first production, variable “B” follows variable “A”.
Since variable “B” starts with terminal “b” or “c”, we
can conclude that these terminals will follow variable “A” as
well. 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">*<B>NOTE </B>: $ is a
special marker that is always in the <B>FOLLOW </B>set of the start
variable. This marker is placed at the end of a string to indicate
the end of the string in parsing. The <B>FOLLOW </B>set for start
variable “S” is only $, since there are no variables or terminals
that follow start variable “S”. 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in; font-weight: medium">After
entering all the <B>FOLLOW </B>sets, click <B>Next</B>. If your
<B>FOLLOW </B>sets are all correct, your <B>LL(1) Parse Table </B>should
look like this : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_3.png" NAME="Graphic4" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<H2 ALIGN=LEFT STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="Enter LL(1) Parse Table|outline"></A>
Enter LL(1) Parse Table</H2>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">There are two main rules for
filling in the table. 1) For production “A-&gt;w”, for each
terminal in <B>FIRST</B>(w), put w as an entry in the A row under the
column for that terminal. 2) For production “A-&gt;w”, if lambda
is in <B>FIRST</B>(w), put w as an entry in the A row under the
columns for all symbols in the <B>FOLLOW</B>(A).</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now, it's time to fill
entries in the parse table. For production “A-&gt;aAc”, we put
“aAc” in column “a” in row “A”. For production
“A-&gt;lambda”, we put lambda in columns “b” and “c” (all
the symbols in <B>FOLLOW</B>(A)). 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">We can apply these rules to
all of the productions and we end up with the parse table :</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_4.png" NAME="Graphic5" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><B>NOTE</B> : If you click
<B>Do All</B>, JFLAP will automatically perform all of the above
tasks for you. If you click <B>Do Step</B> button, JFLAP will create
<B>FIRST </B>set, then <B>FOLLOW </B>set, and finally parse table as
you click the button.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in; font-weight: medium">Now we
are finished with creating LL(1) Parse table, we can use this table
to parse. Click on <B>Parse</B> button and your window should look
like this : 
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_5.png" NAME="Graphic6" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<H2 ALIGN=LEFT STYLE="margin-top: 0in; margin-bottom: 0in"><BR>
</H2>
<H2 ALIGN=LEFT STYLE="margin-top: 0in; margin-bottom: 0in"><A NAME="LL(1) Parsing|outline"></A>
LL(1) Parsing</H2>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Now, let's parse the string
“aacbbcb”. Enter this string in the <B>Input</B> text box and
click on <B>Start</B>. 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in; font-weight: medium">After
clicking <B>Start</B>, at first nothing is going to show on the tree
panel. However, JFLAP will notify you what input string is remaining
to be parsed. After clicking <B>Step</B> once, your window should
look like this :</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_5-1.png" NAME="Graphic6-1" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Note the input string is
listed by “Input Remaining” with the special ending symbol $
added to the right end. Also note the start variable “S” has been
placed on the stack. After clicking on <B>Step</B> again, your window
should look like : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_6.png" NAME="Graphic7" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">The variable “S” has
been popped off the stack and is going to be replaced by its
right-side. The red highlighted portion in the parse table tells you
that JFLAP is going to apply that production to the current variable,
in this case “S”. Also, there is a message at the bottom of the
window which tells you what production JFLAP is applying to the
variable. After clicking the <B>Step</B> button twice more, your
window would look like : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_7.png" NAME="Graphic8" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Notice that the stack is
filling up with the right side of the production. A stack stores
variables and terminals from right sides of productions. Variables
are popped off the stack and replaced by the right side of a
production, and terminals are popped off and matched in the order
they appear in the string. After clicking the <B>Step </B>button
twice more, your window would look like : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_8.png" NAME="Graphic9" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">Notice how the right-side of
“S-&gt;aABb” is now on the stack. In the next <B>Step</B>, JFLAP
matches the “a” on top of the stack with the first “a” in the
Input Remaining and removes both of them. This step is shown in this
window, after you click the <B>Step</B> button.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_9.png" NAME="Graphic10" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in">JFLAP puts the message at
the bottom of the window that tells you that JFLAP matched the first
terminal “a”. You can also see this process using the <B>Derivation
Table </B>and <B>Inverted Tree</B>. After clicking the <B>Step</B>
button numerous times, you will finally reach the end of the parsing.
Your final window should look like one of these : 
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_10.png" NAME="Graphic11" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_11.png" NAME="Graphic12" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><IMG SRC="images/example1_12.png" NAME="Graphic13" ALIGN=MIDDLE WIDTH=600 HEIGHT=484 BORDER=0></P>
<P ALIGN=CENTER STYLE="margin-bottom: 0in"><BR>
</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in"><B>This concludes our brief
tutorial on Building LL(1) Parse Table. Thanks for reading!</B></P>
</BODY>
</HTML>